# Woo Commerce Plugin

**Shopversion:** 
Woo Commerce 3.x - 5.x

**Also needed:** 
Woo Suscription 3.x (if needed)

**Module Path:** 
/wp-content/plugins/woocommerce-gateway-mipa/

**Specials:** 
none

---

## ChangeLog

v1.9.8

* fixed IBAN and BIC issue in case setting new bank account during subscription
* new param customPrefix for handling multi shops in one merchant account
* core update 1.3.5

v1.9.7

* fixed IBAN and BIC issue in case of spaces inside
* fixed CCard 3D Secure Token Empty Issue on Subscription
* core update 1.3.4

v1.9.6

* fixed empty holder issue
* fixed sepa reversal notify issue

v1.9.5

* fixed styling issue on sepa api
* fixed ip issue on scheduled action

v1.9.4

* core update 1.3.3
* added paydate param to sepa
* fixed paytext issue
* added paytype to cart
* added ccard, sepa and prepay as web version
* fixed customer already exists issue on sepa iban error
* fixed creditcard issue in case of subdirectory
* moved icons into css

v1.9.3

* added sepa web
* added ccard web
* added prepay web
* changed some wordings
* fixed freetext issue
* fixed subscription issue ccard
* fixed jump to error page
* added error translation possibility
* removed old code

v1.9.2

* core update 1.3.1
* fixed subscription issue
* fixed sepa reuse issue with existing cutomer
* fixed ccard reuse issue

v1.9.1

* core update 1.3.0
* fixed language issue on prepayment

v1.9.0

* core update 1.2.8
* fixed sepa missing paydata issue in case of subscription

v1.8.0

* fixed some issues with refund on sepa and ccard in case of encoding problems
* added 3D Secure switch to ccard
* core update 1.2.4

v1.7.9

* fixed refund from shop issue
* fixed missing order params in case of ccard

v1.7.8

* fixed guest customer payment issue on ccard
* switched to ccard v2.3 with 3D Secure 2.0
* fixed ccard issue on subscriptions
* fixed ccard issue on response for refund, backpay and chargeback
* fixed language issue in case of AT
* fixed prepay payin issue
* fixed translation issue #30
* fixed default descriptions for paymethods issue #29
* fixed issue #28 paydirekt
* fixed issue #27 description in DE and EN

v1.7.7

* fixed some issues while reusing ccard.
* moved javascript to js files.
* changed ccard and sepa logos
* updated core to newest version 1.2.1
* fixed double constructor issue
* fixed testmode=0 issue
* fixed empty option issue
* fixed currency check issue
* added paydirekt
* changed paytext for prepay with new placeholder for projectid

v1.7.6

* fixed status change in case of WebAPI

v1.7.5

* fixed javascript issue in chrome
* additional call of start scripts in JS
* removed debugging

v1.7.4

* changed default recurring to 1
* fixed double customer prefix 
* fixed missing customer prefix

v1.7.3

* fixed ccard endless loader if clicked on expiration date first
* further enhancements in core
* switched ccard workflow to new 3d secure system

v1.7.2

* fixed issue #26 Reversal on Renewal Order does not set correct status.
* updated core classes to actual version

v1.7.1

* added switch for sofort
* fixed issue #25 sometimes scheduled payments have no country
* added timestamp check in process to prevent double trx

v1.7.0

* fixed issue #18 Payment via paylink ends on wrong error page
* fixed issue #21 IE problems with ccard
* fixed issue #22 Creditcard Month select count error
* fixed issue #23 Call2Pay and HandyPay not shown on virtual variant product.

v1.6.9

* fixed issue #16 Refund on CCard without cent amounts
* fixed issue #17 Session Problem when customer makes mistakes before
* fixed problem with modal window in case of previous error in checkout
* fixed problem with slashes under windows

v1.6.8

* fixed issue #15 In some cases customer were created without bankaccount

v1.6.7

* fixed issue #13 sometimes ip address is empty.
* fixed issue #14 sessionGet before every tokenSessionCreate is too slow

v1.6.6

* fixed orderid issue on refund from Micropayment ControlCenter
* fixed issue with failed refund in case of WP_Error

v1.6.5

* fixed saving orderParams multiple times
* fixed issue #8 Add Micropayment Copyright in Code
* fixed issue #9 CreditCard Session already exists
* fixed issue #10 CreditCard Refund failed on payments with previous error
* fixed issue #11 CreditCard Refund from Micropayment ControlCenter failed
* fixed issue #12 CreditCard Month Input breaks into 2 lines  

v1.6.4

* added new default descriptions
* added new logos
* fixed issue #5 customer id not found
* fixed issue #6 session id already exists
* fixed issue #7 prepayment white page

v1.6.3

* added customer addressdata to ccard and sepa requests
* fixed ccard session and customer id to fit to the other paymethods
* added trxid saving to ccard
* changed some saved comments in case of ccard

v1.6.2

* fixed ccard schedule issue in case of fail
* fixed sepa issue in case of empty sessionid

v1.6.1

* added chargeback check for sepa so you cant pay an open order when there was a chargeback before.

v1.6.0

* added Call2Pay for digital products only
* added HandyPay for digital products only
* fixed backpay notfiy issue of old plugin
* added isVirtual check 
* styled logview

v1.5.3

* fixed encoding issue in case of ccard and cryptid
* fixed logview js output

v1.5.2

* changed ccard reuse design to look same like sepa reuse
* added MIGRATEONE Handling for SEPA to Migrate single customers from old plugin
* added logview to SEPA to debug errors

v1.5.1

* removed Sepa Migration from old Plugin
* removed Sepa Reactivation from old Plugin

v1.5.0

* added Sofort.
* added PayPal
* added PaySafeCard
* added Sepa Migration from old Plugin
* added Sepa Reactivation from old Plugin
* added CCard Response Fallback in case ThankYou page wasnt called.
* changed default min and max values
* added editable descriptions

v1.4.0

* added prepay with notification handling and refund (amount change)
* changed payment logos
* moved some methods into right place
* fixed token issue for CC and Sepa for Subscriptions
* added subscription migration for SEPA first version

v1.3.0

* added notification handling for sepa which handles reversal, backoay and refund in combination with subscriptions.
* reversal (chargeback) will set pending subscriptions to on-hold
* now refund can be done out of the shop or the control center.
* multiple backpay are possible now
* in case of full recharge via backpays the suscriptions will be reactivated automatically
* debug logging added for notifications and subscription handling
* added test methods to core class

v1.2.0

* added sepa paymethod with booking, save card, subscription and refund functionality
* fixed some creditcard issues with guest orders

v1.1.2

* fixed some color problems in fields
* fixed background-color problem in fields

v1.1.1

* added `!important` flag to all css lines to keep gateway
  design unimpressed by shop themes
* removed test credentials
	
v1.1.0

* added subscription ability
* added refund ability
* card will be saved automatically when subscription 
  product is in cart
* if card is deleted, subscription will be cancelled 
  until the order will be paid again.
* if subscription order is paid again with creditcard 
  later and card is saved again, it will continue the 
  subscription automatically

v1.0.1

* added remember card for next purchase
* added reuse old card to checkout
* added payment token management
* card can be seen and deleted on add paymethod page
* new card can only be saved while checkout

v1.0.0

* First version of plugin with paymethod creditcard 
  in pci conform integration.
* With responsive solution for mobile version
	 

## Merchant Setup
We need one project with two paymethods for this setup right now.
First you need the CreditCard Event paymethod and
second you need the CreditCard API.Event paymethod.

#### Project Setup
1. Setup project as usual.
2. Fill all fields and save the project.
3. After creation click again on new project row.
4. Copy and remember the project shortcut. (Kürzel)
5. We need this in the plugin later.

#### CreditCard Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_ccard&orderid=__$orderid__&transactionId=__transactionId__&sessionId=__sessionId__&customerId=__customerId__
	
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### CreditCard API.Event
1. The only thing to setup is the Notify URL.
 
	Please set this to:

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_ccard

2. Click on **Read information on using the API** and mark the checkbox.
3. Click on **Save settings** and you are done.
4. Thats all for this paymethod.

#### Sepa API.Event
1. The only thing to setup is the Notify URL.
 
	Please set this to:

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_sepa

2. Click on **Read information on using the API** and mark the checkbox.
3. Click on **Save settings** and you are done.
4. Thats all for this paymethod.

#### PrePay API.Event
1. The only thing to setup is the Notify URL.
 
	Please set this to:

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_prepay

2. Click on **Read information on using the API** and mark the checkbox.
3. Click on **Save settings** and you are done.
4. Thats all for this paymethod.


#### CreditCard Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_ccard_web&orderid=__$orderid__
	
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### Sepa Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_sepa_web&orderid=__$orderid__
	
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### Prepay Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_prepay_web&orderid=__$orderid__
	
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.


#### Sofort. Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_sofort&orderid=__$orderid__
	
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### PayPal Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_paypal&orderid=__$orderid__&transactionId=__transactionId__
			
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### PaySafeCard Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_paysafecard&orderid=__$orderid__
		
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### Call2Pay Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_call2pay&orderid=__$orderid__
		
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### HandyPay Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_handypay&orderid=__$orderid__
		
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### PayDirekt Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/?wc-api=wc_gateway_mipa_paydirekt&orderid=__$orderid__
			
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.


#### Get Access Key
1. Click on **Setup** in the top navi and then click on **Accessskey**.
2. Copy this hash and remember it for the plugin later.
3. Setup is done so far.

---

## Installing the plugin
1. Login into your WordPress Admin (wp-admin) area.
2. Click on **Plugins** and select **install**.
3. Click on **upload plugin** on top left.
4. Select the plugin zip you got from Micropayment and click on **install now**.
5. Click on **Activate Plugin**.
6. Plugin is installed now.

---

## Configure the plugin
1. Login into your WordPress Admin (wp-admin) area.
2. Click on **WooCommerce** in the navi and select **Settings**.
3. Click on **paymethods** in top navi.
4. Click on **Micropayment CreditCard** in the list.
5. Check that the activation checkbox is checked.
6. Configure the title, description and other settings as you need.
7. Copy the **AccessKey** you remembered while setup and fill it into the settings.
8. Copy the **Project Shortcut (Kürzel)** you remembered while setup and fill it into the settings.
9. Select **Test Mode** as you need to *Test* or *Live*.
10. Click on **Save changes**
11. Done !

---

## Test Credentials
#### VISA
	Number: 4111111111111111 
	CVV: 666 (success)
	or
	CVV: 999 (fail)
	Date: something in future
	
#### MASTERCARD
	Number: 5105105105105100
	CVV: 666 (success)
	or
	CVV: 999 (fail)
	Date: something in future

#### SEPA
	IBAN: DE89888888881234567890
	BIC: TESTDE00XXX
	Owner: Firstname Lastname

#### SOFORT
	BLZ: 88888888
	KTO: 1234567890
	PIN: 1234
	TAN: 12345
	
#### PREPAY
	Nothing special is needed.
	
#### PAYSAFECARD
	Nothing special is needed.

#### PAYDIREKT
	Amount:
	1-3 Euro		Successful with two factor auth
	4 - 500 Euro	Successful without two factor auth
	> 500 Euro	Failed
	
	Two Factor Auth:
	TAN:	123456
	
	User:	micropayment_SDE-Kaeufer 	
	Pass:	SDE-Kaeufer2$ 	
	Desc:	Success < 500 Euro

	User:	micropayment_unterAchtzehn
	Pass:	unterAchtzehn2$
	Desc:	Failed if customer age verification is set to over 18
	
	User:	micropayment_SperreKB
	Pass:	SperreKB2$
	Desc:	Failed due to issuing bank
	
#### PAYPAL
	You will need a special PayPal Sandbox account.
	Please contact our support.

#### CALL2PAY
	Nothing special is needed.
	
#### HANDYPAY
	PhoneNo. 88888888
	SMS-Code: 666
	
## FAQ

	Q: Where is the language "Deutsch (Sie)" ?
	A: Just make a copy of the de_DE files and name them de_DE_formal (dir: languages .po and .mo)

	Q: Status isnt set correctly when selling virtual products.
	A: WooCommerce has its own logic for virtual downloadable products. If you use virtual but not downloadable products, woocommerce sets the status to completed. If the product is virtual and downloadable woocommerce sets the status processing. So please do not choose a status different from WooCommerce defaults, because it would cause a status ping pong. In some cases we had problem with booked coins which where booked every status change and customer got 4 times coins.
	
	Q: ...
	A: ...